// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             (unknown)
// source: services/ci_service.proto

package services

import (
	context "context"
	domain "gitlab.com/ignitionrobotics/cloudsim/api/domain"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ContinuousIntegrationServiceClient is the client API for ContinuousIntegrationService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ContinuousIntegrationServiceClient interface {
	// ListSuites returns a list of domain.Suite entries.
	ListSuites(ctx context.Context, in *ListSuitesRequest, opts ...grpc.CallOption) (*ListSuitesResponse, error)
	// ListSuitesBySHA returns a list of domain.Suite matching the given domain.SHA.
	ListSuitesBySHA(ctx context.Context, in *ListSuiteBySHARequest, opts ...grpc.CallOption) (*ListSuitesResponse, error)
	// RestartSuite triggers a restart of a certain suite in a git provider.
	ReRequestSuite(ctx context.Context, in *ReRequestSuiteRequest, opts ...grpc.CallOption) (*domain.Suite, error)
	// RestartScenario triggers a restart of a certain scenario in a git provider.
	ReRequestScenario(ctx context.Context, in *ReRequestScenarioRequest, opts ...grpc.CallOption) (*domain.Scenario, error)
}

type continuousIntegrationServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewContinuousIntegrationServiceClient(cc grpc.ClientConnInterface) ContinuousIntegrationServiceClient {
	return &continuousIntegrationServiceClient{cc}
}

func (c *continuousIntegrationServiceClient) ListSuites(ctx context.Context, in *ListSuitesRequest, opts ...grpc.CallOption) (*ListSuitesResponse, error) {
	out := new(ListSuitesResponse)
	err := c.cc.Invoke(ctx, "/services.ContinuousIntegrationService/ListSuites", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *continuousIntegrationServiceClient) ListSuitesBySHA(ctx context.Context, in *ListSuiteBySHARequest, opts ...grpc.CallOption) (*ListSuitesResponse, error) {
	out := new(ListSuitesResponse)
	err := c.cc.Invoke(ctx, "/services.ContinuousIntegrationService/ListSuitesBySHA", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *continuousIntegrationServiceClient) ReRequestSuite(ctx context.Context, in *ReRequestSuiteRequest, opts ...grpc.CallOption) (*domain.Suite, error) {
	out := new(domain.Suite)
	err := c.cc.Invoke(ctx, "/services.ContinuousIntegrationService/ReRequestSuite", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *continuousIntegrationServiceClient) ReRequestScenario(ctx context.Context, in *ReRequestScenarioRequest, opts ...grpc.CallOption) (*domain.Scenario, error) {
	out := new(domain.Scenario)
	err := c.cc.Invoke(ctx, "/services.ContinuousIntegrationService/ReRequestScenario", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ContinuousIntegrationServiceServer is the server API for ContinuousIntegrationService service.
// All implementations must embed UnimplementedContinuousIntegrationServiceServer
// for forward compatibility
type ContinuousIntegrationServiceServer interface {
	// ListSuites returns a list of domain.Suite entries.
	ListSuites(context.Context, *ListSuitesRequest) (*ListSuitesResponse, error)
	// ListSuitesBySHA returns a list of domain.Suite matching the given domain.SHA.
	ListSuitesBySHA(context.Context, *ListSuiteBySHARequest) (*ListSuitesResponse, error)
	// RestartSuite triggers a restart of a certain suite in a git provider.
	ReRequestSuite(context.Context, *ReRequestSuiteRequest) (*domain.Suite, error)
	// RestartScenario triggers a restart of a certain scenario in a git provider.
	ReRequestScenario(context.Context, *ReRequestScenarioRequest) (*domain.Scenario, error)
	mustEmbedUnimplementedContinuousIntegrationServiceServer()
}

// UnimplementedContinuousIntegrationServiceServer must be embedded to have forward compatible implementations.
type UnimplementedContinuousIntegrationServiceServer struct {
}

func (UnimplementedContinuousIntegrationServiceServer) ListSuites(context.Context, *ListSuitesRequest) (*ListSuitesResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListSuites not implemented")
}
func (UnimplementedContinuousIntegrationServiceServer) ListSuitesBySHA(context.Context, *ListSuiteBySHARequest) (*ListSuitesResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListSuitesBySHA not implemented")
}
func (UnimplementedContinuousIntegrationServiceServer) ReRequestSuite(context.Context, *ReRequestSuiteRequest) (*domain.Suite, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ReRequestSuite not implemented")
}
func (UnimplementedContinuousIntegrationServiceServer) ReRequestScenario(context.Context, *ReRequestScenarioRequest) (*domain.Scenario, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ReRequestScenario not implemented")
}
func (UnimplementedContinuousIntegrationServiceServer) mustEmbedUnimplementedContinuousIntegrationServiceServer() {
}

// UnsafeContinuousIntegrationServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ContinuousIntegrationServiceServer will
// result in compilation errors.
type UnsafeContinuousIntegrationServiceServer interface {
	mustEmbedUnimplementedContinuousIntegrationServiceServer()
}

func RegisterContinuousIntegrationServiceServer(s grpc.ServiceRegistrar, srv ContinuousIntegrationServiceServer) {
	s.RegisterService(&ContinuousIntegrationService_ServiceDesc, srv)
}

func _ContinuousIntegrationService_ListSuites_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListSuitesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContinuousIntegrationServiceServer).ListSuites(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/services.ContinuousIntegrationService/ListSuites",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContinuousIntegrationServiceServer).ListSuites(ctx, req.(*ListSuitesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ContinuousIntegrationService_ListSuitesBySHA_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListSuiteBySHARequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContinuousIntegrationServiceServer).ListSuitesBySHA(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/services.ContinuousIntegrationService/ListSuitesBySHA",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContinuousIntegrationServiceServer).ListSuitesBySHA(ctx, req.(*ListSuiteBySHARequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ContinuousIntegrationService_ReRequestSuite_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ReRequestSuiteRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContinuousIntegrationServiceServer).ReRequestSuite(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/services.ContinuousIntegrationService/ReRequestSuite",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContinuousIntegrationServiceServer).ReRequestSuite(ctx, req.(*ReRequestSuiteRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ContinuousIntegrationService_ReRequestScenario_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ReRequestScenarioRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContinuousIntegrationServiceServer).ReRequestScenario(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/services.ContinuousIntegrationService/ReRequestScenario",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContinuousIntegrationServiceServer).ReRequestScenario(ctx, req.(*ReRequestScenarioRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// ContinuousIntegrationService_ServiceDesc is the grpc.ServiceDesc for ContinuousIntegrationService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ContinuousIntegrationService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "services.ContinuousIntegrationService",
	HandlerType: (*ContinuousIntegrationServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "ListSuites",
			Handler:    _ContinuousIntegrationService_ListSuites_Handler,
		},
		{
			MethodName: "ListSuitesBySHA",
			Handler:    _ContinuousIntegrationService_ListSuitesBySHA_Handler,
		},
		{
			MethodName: "ReRequestSuite",
			Handler:    _ContinuousIntegrationService_ReRequestSuite_Handler,
		},
		{
			MethodName: "ReRequestScenario",
			Handler:    _ContinuousIntegrationService_ReRequestScenario_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "services/ci_service.proto",
}
